using System;

namespace IceShock
{
	/// <summary>
	/// Summary description for DialogPage.
	/// </summary>
	public class DialogPage: System.Web.UI.Page
	{
		#region Members
		private System.Web.UI.WebControls.Button _OKButton;
		private System.Web.UI.WebControls.Button _CancelButton;

		protected System.Web.UI.WebControls.Button OKButton
		{
			get
			{
				return _OKButton;
			}
			set
			{
				_OKButton = value;
				_OKButton.Click +=new EventHandler(_OKButton_Click);
				_OKButton.TabIndex = 20;
				
				

			}
		}
		protected System.Web.UI.WebControls.Button CancelButton
		{
			get
			{
				return _CancelButton;

			}
			set
			{
				_CancelButton = value;
				_CancelButton.Click +=new EventHandler(_CancelButton_Click);
				_CancelButton.TabIndex = 10;
				RegisterStartupScript("focusDialog", 
					@"<script language='javascript'>
							var prev_onload = window.onload;//careful not to have other vars with same name
							window.onload = function() {
								document.getElementById('" + _CancelButton.ClientID + @"').focus();
								if(prev_onload)
								return prev_onload();
								else
								return true;
								};</script>");
			}
		}

		#endregion
		
		

		private void _OKButton_Click(object sender, EventArgs e)
		{
			//this is essential to close the dialog that contains this page Check the ModalDialogControl
			RegisterStartupScript("closeDialog", "<script>window.top.hidePopWin(true)</script>");
		}

		private void _CancelButton_Click(object sender, EventArgs e)
		{
			//this is essential to close the dialog that contains this page Check the ModalDialogControl
			RegisterStartupScript("closeDialog", "<script>window.top.hidePopWin(false)</script>");
		}

		protected override void OnPreRender(EventArgs e)
		{
			base.OnPreRender (e);
			if(_OKButton == null && _CancelButton == null)
			{
				throw new Exception("The OKButton and/or CancelButton must be set to a valid Button");
				
			}
			if(_CancelButton == null)
					RegisterStartupScript("focusDialog", 
						@"<script language='javascript'>
							var prev_onload = window.onload;//careful not to have other vars with same name
							window.onload = function() {
								document.getElementById('" + _OKButton.ClientID + @"').focus();
								if(prev_onload)
								return prev_onload();
								else
								return true;
								};</script>");
					


		}

		

	}
}
